        subroutine findR0_LZ_NT(sigma,delta,dir,r,R0,ead,etot1d,
     &                    natom,nsurf,ilower,iupper,ierr,
     &       ex,eup_t10,elow_t10,eup_t20,elow_t20,eup_r0,elow_r0,
     &                    gamma,aa,del11,del22,is0,t1,t2,t1l,t1r,
     &                    t10,t20,rb,eb,rt,et,key1,key2)
        implicit none
        integer natom,nsurf,ilower,iupper,ierr
        real*8 dir(3,*),r(3,*),sigma,delta,R0,ead(*),etot1d
*
*       delta=vlarge(iupper)-vlarge(ilower)
*       dir: direction of non-adiabatic coupling
*
        real*8 err_rel
        common/err_rel/err_rel
*
        integer,parameter :: isecant=1,maxn=200
        real*8 x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11
        real*8 de1,de2,de3,de4,de5,de6,de7,de8,de9,de10,de11
        real*8 dde1,dde2
        real*8 dx,absdx,temp, h, h1
        integer nstep,i,j,nlr
        real*8, parameter :: maxdx=1.0d0,maxn_sec=10
        real*8, parameter :: err_dx=1.0d-3,largest_step=5.0d0
        integer, parameter :: idbg=0, inum=0
        real*8 dde3
        real*8 e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,ex
        real*8 e11,e12,e21,e22,e1up,e2up,e1l,e1r
        real*8 xx,ee,xxx(maxn),eee(maxn),sum,k(maxn),dx_err(maxn)
        real*8 delow(maxn),deup(maxn),elow(maxn),eup(maxn),dde(maxn)
        real*8 elowl(maxn),eupl(maxn),elowr(maxn),eupr(maxn)
        real*8 delowl(maxn),deupl(maxn),delowr(maxn),deupr(maxn)
        real*8 elow_r0,eup_r0,delow_r0,deup_r0
        real*8 elow_t10,eup_t10,elow_t20,eup_t20
        real*8 x(maxn),xl(maxn),xr(maxn)
        real*8 t10,t20,rb,eb,rt,et,t1,t2,t1l,t1r
        real*8 min_low,min_up
        real*8 hess_rt,hess_rb,del11,del22
        real*8 gamma,aa
        integer ll,rr,icount
        integer m,is0
        integer n,nmax,key1,key2,key4,key6,key8,key10,key12,key14
        real*8 maxh,dh1,dh2
        maxh=5.0d0
        icount=0
        key1=0
        key2=0
        key4=0
        key6=0
        key8=0
        key10=0
        key12=0
        key14=0
*
*       if (idbg == 1) then
          write(*,*) '*****************'
          write(*,*) 'Welcome to findR0_LZ_NT'
          write(*,*) '*****************'
*       endif
*
        err_rel=err_dx
*
        ierr=0
        if(delta == 0.d0)stop'delta=0 in findR0_LZ_NT'
*
        do n=1,maxn
          x(n)=0.0d0
          elow(n)=0.0d0
          eup(n)=0.0d0
          delow(n)=0.0d0
          deup(n)=0.0d0
          dde(n)=0.0d0
        enddo

          n=1
          x1=0.0d0
          x(n)=x1
          call der1d(r,x1,dir,e1,de1,natom,nsurf,ilower,inum)
          call der1d(r,x1,dir,e2,de2,natom,nsurf,iupper,inum)
          elow(n)=e1
          eup(n)=e2
          delow(n)=de1
          deup(n)=de2
          dde(n)=de2-de1
          dde1=de2-de1
          n=2
          x2=0.5d0
          x(n)=x2
          call der1d(r,x2,dir,e1,de1,natom,nsurf,ilower,inum)
          call der1d(r,x2,dir,e2,de2,natom,nsurf,iupper,inum)
          elow(n)=e1
          eup(n)=e2
          delow(n)=de1
          deup(n)=de2
          dde(n)=de2-de1
          dde2=de2-de1
          do while (n < maxn .and. abs(x2-x1) > err_dx )
            dx=-(x2-x1)*dde2/(dde2-dde1)
            write(*,*) 'n,x2,dde2,dx in findR0_LZ_NT=',n,x2,dde2,dx
            if (abs(dx) > maxh) then
              dx=sign(maxh,dx)
            endif
            x3=x2+dx
            dx_err(n)=dx
            if (n>=3) then
              if(dx_err(n)*dx_err(n-1) < 0.0d0) then
                maxh=maxh-1.0d0
              endif
            endif
            if (delow(n)*delow(n-1) < 0) then
              key4=1
              x4=x1
              x5=x2
              e4=e1
              e5=e2
              de4=de1
              de5=de2
            endif
            if (deup(n)*deup(n-1) < 0) then
              key6=1
              x6=x1
              x7=x2
              e6=e1
              e7=e2
              de6=de1
              de7=de2
            endif
            n=n+1
            call der1d(r,x3,dir,e1,de1,natom,nsurf,ilower,inum)
            call der1d(r,x3,dir,e2,de2,natom,nsurf,iupper,inum)
            dde3=de2-de1
            write(*,*) 'n,x3,dde3 in findR0_LZ_NT=',n,x3,dde3
            x1=x2
            x2=x3
            dde1=dde2
            dde2=dde3
            x(n)=x3
            elow(n)=e1
            eup(n)=e2
            delow(n)=de1
            deup(n)=de2
            dde(n)=de2-de1
          enddo
*
          R0=x3
          write(*,*) 'n,R0=',n,R0

          elow_r0=e1
          eup_r0=e2
          delow_r0=de1
          deup_r0=de2

          rr=0
          ll=0
          do i=1,n
            if (x(i)-R0 > 0.0d0) then
              rr=rr+1
              xr(rr)=x(i)
              elowr(rr)=elow(i)
              eupr(rr)=eup(i)
              delowr(rr)=delow(i)
              deupr(rr)=deup(i)
            elseif (x(i)-R0 < 0.0d0) then
              ll=ll+1
              xl(ll)=x(i)
              elowl(ll)=elow(i)
              eupl(ll)=eup(i)
              delowl(ll)=delow(i)
              deupl(ll)=deup(i)
            endif
          enddo

          ex=0.5d0*(e1+e2)
        write(*,*)
        write(*,*)'ex inside hop=',ex
        write(*,*)
*
 100    continue
          maxh=5.0d0
          if ((key4==1).and.(key6==1)) then
            x3=0.0d0
            e3=0.0d0
            x1=x4
            x2=x5
            e1=e4
            e2=e5
            de1=de4
            de2=de5
            write(*,*)'x1,x2,de1,de2',x1,x2,de1,de2
            h =-(x2-x1)*de2/(de2-de1)
            write(*,*)'h',h
            dh1=h
            dh2=h
            x3=x2
            e3=e2
            do while (n < maxn .and. abs(h) > err_dx )
              n=n+1
              if ( abs(h) > maxh ) h=sign(maxh,h)
                x3=x2+h
              write(*,'(a,2f10.5,1pe10.2)')
     &              'new h,x3,err_dx in 11_rt=',h,x3,err_dx
              call der1d_mura
     &        (r,x3,dir,e3,de3,natom,nsurf,ilower,inum,iupper,e4)
              write(*,*) 'n,x3,e3,de3 in 11_rt=',n,x3,e3,de3
              x1=x2
              x2=x3
              x(n)=x3
              de1=de2
              de2=de3
              e1 =e2
              e2 =e3
              elow(n)=e3
              eup(n)=e4
              h =-(x2-x1)*de2/(de2-de1)
              write(*,*)'h',h
              nmax=n
              dh1=dh2
              dh2=h
              if(dh1*dh2 < 0.0d0) then
                maxh=maxh-1.0d0
              endif
            enddo
*
            rt=x3
            et=e3
            key1=1

            write(*,'(a,2f10.5,1pe10.2)')
     &           'Last h,x3,err_dx in 11_rt=',h,x3,err_dx
            write(*,*)
*
          maxh=5.0d0
            x3=0.0d0
            e3=0.0d0
            x1=x6
            x2=x7
            e1=e6
            e2=e7
            de1=de6
            de2=de7
            h =-(x2-x1)*de2/(de2-de1)
            dh1=h
            dh2=h
            x3=x2
            e3=e2
            do while (n < maxn .and. abs(h) > err_dx )
              n=n+1
              if ( abs(h) > maxh ) h=sign(maxh,h)
              x3=x2+h
              write(*,'(a,2f10.5,1pe10.2)')
     &              'new h,x3,err_dx in 11_rb=',h,x3,err_dx
              call der1d_mura
     &        (r,x3,dir,e3,de3,natom,nsurf,iupper,inum,ilower,e4)
              write(*,*) 'n,x3,e3,de3 in 11_rb=',n,x3,e3,de3
              x1=x2
              x2=x3
              x(n)=x3
              de1=de2
              de2=de3
              e1 =e2
              e2 =e3
              eup(n)=e3
              elow(n)=e4
              h =-(x2-x1)*de2/(de2-de1)
              nmax=n
              dh1=dh2
              dh2=h
              if(dh1*dh2 < 0.0d0) then
                maxh=maxh-1.0d0
              endif
            enddo
*
            rb=x3
            eb=e3
            key2=1

            write(*,'(a,2f10.5,1pe10.2)')
     &           'Last h,x3,err_dx in 11_rb=',h,x3,err_dx
            write(*,*)
          endif
*
          if ((key4==1).and.(key6==0)) then
          maxh=5.0d0
            x3=0.0d0
            e3=0.0d0
             h=maxh
            x1=x4
            x2=x5
            e1=e4
            e2=e5
            de1=de4
            de2=de5
            h=-(x2-x1)*de2/(de2-de1)
            dh1=h
            dh2=h
            x3=x2
            e3=e2
            do while (n < maxn .and. abs(h) > err_dx )
              n=n+1
              if ( abs(h) > maxh ) h=sign(maxh,h)
              x3=x2+h
              write(*,'(a,2f10.5,1pe10.2)')
     &              'new h,x3,err_dx in 10_rt=',h,x3,err_dx
              call der1d_mura
     &        (r,x3,dir,e3,de3,natom,nsurf,ilower,inum,iupper,e4)
              write(*,*) 'n,x3,e3,de3 in 10_rt=',n,x3,e3,de3
              x1=x2
              x2=x3
              x(n)=x3
              de1=de2
              de2=de3
              e1 =e2
              e2 =e3
              elow(n) =e3
              eup(n) =e4
              h =-(x2-x1)*de2/(de2-de1)
              nmax=n
              dh1=dh2
              dh2=h
              if(dh1*dh2 < 0.0d0) then
                maxh=maxh-1.0d0
              endif
            enddo
*
            rt=x3
            et=e1
            key1=1

            write(*,'(a,2f10.5,1pe10.2)')
     &           'Last h,x3,err_dx in 10_rt=',h,x3,err_dx
            write(*,*)

          maxh=5.0d0
            x3=0.0d0
            e3=0.0d0
            if ((rt-R0 >= 0.0d0) .and. ll >= 2) then
            x1=R0
            x2=xl(2)
            e2=eupl(2)
            de1=deup_r0
            de2=deupl(2)
            write(*,*) 'x1,x2,e2,de1,de2,rt-R0>=0, ll>=2 in 10_rb='
     &      ,x1,x2,e2,de1,de2
            elseif ((rt-R0 < 0.0d0) .and. rr >=2) then
            x1=R0
            x2=xr(2)
            e2=eupr(2)
            de1=deup_r0
            de2=deupr(2)
            write(*,*) 'x1,x2,e2,de1,de2,rt-R0<0, rr>=2 in 10_rb='
     &      ,x1,x2,e2,de1,de2
            elseif ((rt-R0 >= 0.0d0) .and. ll <= 1) then
            x1=R0
            de1=deup_r0
            x2=R0-0.5d0
              call der1d_mura
     &        (r,x2,dir,e2,de2,natom,nsurf,iupper,inum,ilower,e4)
            n=n+1
            eup(n)=e2
            elow(n)=e4
            write(*,*) 'x1,x2,e2,de1,de2,rt-R0>=0, ll<1 in 10_rb='
     &      ,x1,x2,e2,de1,de2
            elseif ((rt-R0 < 0.0d0) .and. rr <= 1) then
            x1=R0
            de1=deup_r0
            x2=R0+0.5d0
              call der1d_mura
     &        (r,x2,dir,e2,de2,natom,nsurf,iupper,inum,ilower,e4)
            n=n+1
            eup(n)=e2
            elow(n)=e4
            write(*,*) 'x1,x2,e2,de1,de2,rt-R0<0, rr<1 in 10_rb='
     &      ,x1,x2,e2,de1,de2
            endif
            h =-(x2-x1)*de2/(de2-de1)
            dh1=h
            dh2=h
            x3=x2
            e3=e2
            do while (n < maxn .and. abs(h) > err_dx )
              n=n+1
              if ( abs(h) > maxh ) h=sign(maxh,h)
              x3=x2+h
              write(*,'(a,2f10.5,1pe10.2)')
     &              'new h,x3,err_dx in 10_rb=',h,x3,err_dx
              call der1d_mura
     &        (r,x3,dir,e3,de3,natom,nsurf,iupper,inum,ilower,e4)
              write(*,*) 'n,x3,e3,de3 in 10_rb=',n,x3,e3,de3
              x1=x2
              x2=x3
              x(n)=x3
              de1=de2
              de2=de3
              e1 =e2
              e2 =e3
              eup(n) =e3
              elow(n) =e4
              h =-(x2-x1)*de2/(de2-de1)
              nmax=n
              dh1=dh2
              dh2=h
              if(dh1*dh2 < 0.0d0) then
                maxh=maxh-1.0d0
              endif
            enddo
*
            rb=x3
            eb=e3
            key2=1

            write(*,'(a,2f10.5,1pe10.2)')
     &           'Last h,x3,err_dx in 10_rb=',h,x3,err_dx
            write(*,*)
*
          endif
*
          if ((key4==0).and.(key6==1)) then
          maxh=5.0d0
            x3=0.0d0
            e3=0.0d0
            x1=x6
            x2=x7
            e1=e6
            e2=e7
            de1=de6
            de2=de7
            h=-(x2-x1)*de2/(de2-de1)
            dh1=h
            dh2=h
            x3=x2
            e3=e2
            do while (n < maxn .and. abs(h) > err_dx )
              n=n+1
              if ( abs(h) > maxh ) h=sign(maxh,h)
              x3=x2+h
              write(*,'(a,2f10.5,1pe10.2)')
     &              'new h,x3,err_dx in 01_rb=',h,x3,err_dx
              call der1d_mura
     &        (r,x3,dir,e3,de3,natom,nsurf,iupper,inum,ilower,e4)
              write(*,*) 'n,x3,e3,de3 in 01_rb=',n,x3,e3,de3
              x1=x2
              x2=x3
              x(n)=x3
              de1=de2
              de2=de3
              e1 =e2
              e2 =e3
              eup(n) =e3
              elow(n) =e4
              h =-(x2-x1)*de2/(de2-de1)
              nmax=n
              dh1=dh2
              dh2=h
              if(dh1*dh2 < 0.0d0) then
                maxh=maxh-1.0d0
              endif
            enddo
*
            rb=x3
            eb=e3
            key2=1
*
            write(*,'(a,2f10.5,1pe10.2)')
     &           'Last h,x3,err_dx in 01_rb=',h,x3,err_dx
            write(*,*)

          maxh=5.0d0
            x3=0.0d0
            e3=0.0d0
             h=maxh
            if ((rb-R0 >= 0.0d0) .and. ll >= 2) then
            x1=R0
            x2=xl(2)
            e2=elowl(2)
            de1=delow_r0
            de2=delowl(2)
            write(*,*) 'x1,x2,e2,de1,de2,rb-R0>=0, ll>=2 in 01_rt='
     &      ,x1,x2,e2,de1,de2
            elseif ((rb-R0 < 0.0d0) .and. rr >=2) then
            x1=R0
            x2=xr(2)
            e2=elow_r0
            de1=delow_r0
            de2=delowr(2)
            write(*,*) 'x1,x2,e2,de1,de2,rb-R0<0, rr>=2 in 01_rt='
     &      ,x1,x2,e2,de1,de2
            elseif ((rb-R0 >= 0.0d0) .and. ll <= 1) then
            x1=R0
            de1=delow_r0
            x2=R0-0.5d0
            call der1d_mura
     &        (r,x2,dir,e2,de2,natom,nsurf,ilower,inum,iupper,e4)
            n=n+1
            elow(n)=e2
            eup(n)=e4
            write(*,*) 'x1,x2,e2,de1,de2,rb-R0>=0, ll<1 in 01_rt='
     &      ,x1,x2,e2,de1,de2
            elseif ((rb-R0 < 0.0d0) .and. rr <= 1) then
            x1=R0
            de1=delow_r0
            x2=R0+0.5d0
            call der1d_mura
     &        (r,x2,dir,e2,de2,natom,nsurf,ilower,inum,iupper,e4)
            n=n+1
            elow(n)=e2
            eup(n)=e4
            write(*,*) 'x1,x2,e2,de1,de2,rb-R0<0, rr<1 in 01_rt='
     &      ,x1,x2,e2,de1,de2
            endif
            h =-(x2-x1)*de2/(de2-de1)
            dh1=h
            dh2=h
            x3=x2
            e3=e2
            do while (n < maxn .and. abs(h) > err_dx )
              n=n+1
              if ( abs(h) > maxh ) h=sign(maxh,h)
              x3=x2+h
              write(*,'(a,2f10.5,1pe10.2)')
     &              'new h,x3,err_dx in 01_rt=',h,x3,err_dx
              call der1d_mura
     &        (r,x2,dir,e2,de2,natom,nsurf,ilower,inum,iupper,e4)
              write(*,*) 'n,x3,e3,de3 in 01_rt=',n,x3,e3,de3
              x1=x2
              x2=x3
              x(n)=x3
              de1=de2
              de2=de3
              e1 =e2
              e2 =e3
              elow(n) =e3
              eup(n) =e4
              h =-(x2-x1)*de2/(de2-de1)
              nmax=n
              dh1=dh2
              dh2=h
              if(dh1*dh2 < 0.0d0) then
                maxh=maxh-1.0d0
              endif
            enddo
*
            rt=x3
            et=e3
            key1=1
*
            write(*,'(a,2f10.5,1pe10.2)')
     &           'Last h,x3,err_dx in 01_rt=',h,x3,err_dx
            write(*,*)
          endif

          if ((key4==0).and.(key6==0)) then
          maxh=5.0d0
          t10=0.0d0
          t20=0.0d0
          min_low=abs(elow(1)-ex)
          min_up=abs(eup(1)-ex)
            do i=2,n
              if  (min_low > abs(elow(i)-ex)) then
                min_low=abs(elow(i)-ex)
                x8=x(i)
                e8=elow(i)
              endif
              if ((elow(i)-ex)*(elow(i-1)-ex) < 0) then
                key12=1
                x8=x(i-1)
                x9=x(i)
                e8=elow(i-1)
                e9=elow(i)
              endif
              if (min_up > abs(eup(i)-ex)) then
                min_up=abs(eup(i)-ex)
                x10=x(i)
                e10=eup(i)
              endif
              if ((eup(i)-ex)*(eup(i-1)-ex) < 0) then
                key14=1
                x10=x(i-1)
                x11=x(i)
                e10=eup(i-1)
                e11=eup(i)
              endif
            enddo
          endif

*
         if((key12==1).and.(key14==1))then
          maxh=5.0d0
            x3=0.0d0
            e3=0.0d0
            x1=x8
            x2=x9
            e1=e8
            e2=e9
            h =-(x2-x1)*(e2-ex)/((e2-ex)-(e1-ex))
            dh1=h
            dh2=h
            x3=x2
            call pot1d(r,x3,dir,ead,natom,nsurf)
            n=n+1
            elow(n)=ead(ilower)
            eup(n)=ead(iupper)
            do while (n < maxn .and. abs(h) > err_dx )
              n=n+1
              if ( abs(h) > maxh ) h=sign(maxh,h)
              x3=x2+h
              write(*,'(a,3f10.5,1pe10.2)')
     &              'new h,x3,ex,err_dx in 11_t10=',h,x3,ex,err_dx
              call pot1d(r,x3,dir,ead,natom,nsurf)
              elow(n)=ead(ilower)
              eup(n)=ead(iupper)
              write(*,*) 'n,x3,ex,elow in 11_t10=',n,x3,ex,elow(n)
              x1=x2
              x2=x3
              x(n)=x3
               h=-(x2-x1)*(elow(n)-ex)
     &           /((elow(n)-ex)-(elow(n-1)-ex))
              nmax=n
              dh1=dh2
              dh2=h
              if(dh1*dh2 < 0.0d0) then
                maxh=maxh-1.0d0
              endif
            enddo
*
            t10=x3
            elow_t10=elow(n)
            eup_t10=eup(n)
            key8=1
            key1=0
            key2=0

            write(*,'(a,3f10.5,1pe10.2)')
     &           'Last h,x3,ex,err_dx in 11_t10=',h,x3,ex,err_dx
            write(*,*)
*
          maxh=5.0d0
            x3=0.0d0
            e3=0.0d0
            x1=x10
            x2=x11
            e1=e10
            e2=e11
            h =-(x2-x1)*(e2-ex)/((e2-ex)-(e1-ex))
            dh1=h
            dh2=h
            x3=x2
            call pot1d(r,x3,dir,ead,natom,nsurf)
            n=n+1
            elow(n)=ead(ilower)
            eup(n)=ead(iupper)
            do while (n < maxn .and. abs(h) > err_dx )
              n=n+1
              if ( abs(h) > maxh ) h=sign(maxh,h)
              x3=x2+h
              write(*,'(a,3f10.5,1pe10.2)')
     &              'new h,x3,ex,err_dx in 11_t20=',h,x3,ex,err_dx
              call pot1d(r,x3,dir,ead,natom,nsurf)
              elow(n)=ead(ilower)
              eup(n)=ead(iupper)
              write(*,*) 'n,x3,ex,eup in 11_t20=',n,x3,ex,eup(n)
              x1=x2
              x2=x3
              x(n)=x3
              h=-(x2-x1)*(eup(n)-ex)
     &          /((eup(n)-ex)-(eup(n-1)-ex))
              nmax=n
              dh1=dh2
              dh2=h
              if(dh1*dh2 < 0.0d0) then
                maxh=maxh-1.0d0
              endif
            enddo
*
            t20=x3
            eup_t20=eup(n)
            elow_t20=elow(n)
            key10=1
            key1=0
            key2=0

            write(*,'(a,3f10.5,1pe10.2)')
     &           'Last h,x3,ex,err_dx in 11_t20=',h,x3,ex,err_dx
            write(*,*)
          endif
*
         if((key12==1).and.(key14==0))then
          maxh=5.0d0
            x3=0.0d0
            e3=0.0d0
            x1=x8
            x2=x9
            e1=e8
            e2=e9
            h=-(x2-x1)*(e2-ex)/((e2-ex)-(e1-ex))
            dh1=h
            dh2=h
            x3=x2
            call pot1d(r,x3,dir,ead,natom,nsurf)
            elow(n)=ead(ilower)
            eup(n)=ead(iupper)
            do while (n < maxn .and. abs(h) > err_dx )
              n=n+1
              if ( abs(h) > maxh ) h=sign(maxh,h)
              x3=x2+h
              write(*,'(a,3f10.5,1pe10.2)')
     &              'new h,x3,ex,err_dx in 10_t10=',h,x3,ex,err_dx
              call pot1d(r,x3,dir,ead,natom,nsurf)
              elow(n)=ead(ilower)
              eup(n)=ead(iupper)
              write(*,*) 'n,x3,ex,elow in 10_t10=',n,x3,ex,elow(n)
              x1=x2
              x2=x3
              x(n)=x3
              h=-(x2-x1)*(elow(n)-ex)
     &           /((elow(n)-ex)-(elow(n-1)-ex))
              nmax=n
              dh1=dh2
              dh2=h
              if(dh1*dh2 < 0.0d0) then
                maxh=maxh-1.0d0
              endif
            enddo
*
            t10=x3
            elow_t10=elow(n)
            eup_t10=eup(n)
            key8=1
            key1=0
            key2=0

            write(*,'(a,3f10.5,1pe10.2)')
     &           'Last h,x3,ex,err_dx in 10_t10=',h,x3,ex,err_dx
            write(*,*)
*
          maxh=5.0d0
            x3=0.0d0
            e3=0.0d0
            if ((t10-R0 >= 0.0d0) .and. ll >= 2) then
            x1=R0
            x2=xl(2)
            e1=eup_r0
            e2=eupl(2)
            eup(n)=eup_r0
            elow(n)=elow_r0
            write(*,*) 'x1,x2,e1,e2,ex:t10-R0<0, ll>=2 in 10_t20='
     &      ,x1,x2,e1,e1,ex
            elseif ((t10-R0 < 0.0d0) .and. rr >=2) then
            x1=R0
            x2=xr(2)
            e1=eup_r0
            e2=eupr(2)
            eup(n)=eup_r0
            elow(n)=elow_r0
            write(*,*) 'x1,x2,e1,e2,ex:t10-R0<0, rr>=2 in 10_t20='
     &      ,x1,x2,e1,e2,ex
            elseif ((t10-R0 >= 0.0d0) .and. ll <= 1) then
            x1=R0
            e1=eup_r0
            x2=R0-0.5d0
            call pot1d(r,x2,dir,ead,natom,nsurf)
            n=n+1
            e2=ead(iupper)
            eup(n)=ead(iupper)
            elow(n)=ead(ilower)
            write(*,*) 'x1,x2,e1,e2,ex:t10-R0<0, ll<1 in 10_t20='
     &      ,x1,x2,e1,e2,ex
            elseif ((t10-R0 < 0.0d0) .and. rr <= 1) then
            x1=R0
            e1=eup_r0
            x2=R0+0.5d0
            call pot1d(r,x2,dir,ead,natom,nsurf)
            n=n+1
            e2=ead(iupper)
            eup(n)=ead(iupper)
            elow(n)=ead(ilower)
            write(*,*) 'x1,x2,e1,e2,ex:t10-R0<0, rr<1 in 10_t20='
     &      ,x1,x2,e1,e2,ex
            endif
            h =-(x2-x1)*(e2-ex)/((e2-ex)-(e1-ex))
            dh1=h
            dh2=h
              write(*,'(a,3f10.5,1pe10.2)')
     &              'new h,x2,ex,err_dx in 10_t20=',h,x2,ex,err_dx
            x3=x2
            call pot1d(r,x2,dir,ead,natom,nsurf)
            n=n+1
            eup(n)=ead(iupper)
            elow(n)=ead(ilower)
            do while (n < maxn .and. abs(h) > err_dx )
              n=n+1
              if ( abs(h) > maxh ) h=sign(maxh,h)
              x3=x2+h
              write(*,'(a,3f10.5,1pe10.2)')
     &              'new h,x3,ex,err_dx in 10_t20=',h,x3,ex,err_dx
              call pot1d(r,x3,dir,ead,natom,nsurf)
              elow(n)=ead(ilower)
              eup(n)=ead(iupper)
              write(*,*) 'n,x3,ex,eup in 10_t20=',n,x3,ex,eup(n)
              write(*,'(1x)')
              x1=x2
              x2=x3
              x(n)=x3
              h=-(x2-x1)*(eup(n)-ex)
     &           /((eup(n)-ex)-(eup(n-1)-ex))
              nmax=n
              dh1=dh2
              dh2=h
              if(dh1*dh2 < 0.0d0) then
                maxh=maxh-1.0d0
              endif
            enddo
*
            t20=x3
            eup_t20=eup(n)
            elow_t20=elow(n)
            key10=1
            key1=0
            key2=0

            write(*,'(a,3f10.5,1pe10.2)')
     &           'Last h,x3,ex,err_dx in 10_t20=',h,x3,ex,err_dx
            write(*,*)
*
          endif
*
         if((key12==0).and.(key14==1))then
          maxh=5.0d0
            x3=0.0d0
            e3=0.0d0
            x1=x10
            x2=x11
            e1=e10
            e2=e11
            h=-(x2-x1)*(e2-ex)/((e2-ex)-(e1-ex))
            dh1=h
            dh2=h
            x3=x2
            call pot1d(r,x3,dir,ead,natom,nsurf)
            n=n+1
            elow(n)=ead(ilower)
            eup(n)=ead(iupper)
            do while (n < maxn .and. abs(h) > err_dx )
              n=n+1
              if ( abs(h) > maxh ) h=sign(maxh,h)
              x3=x2+h
              write(*,'(a,3f10.5,1pe10.2)')
     &              'new h,x3,ex,err_dx in 01_t20=',h,x3,ex,err_dx
              call pot1d(r,x3,dir,ead,natom,nsurf)
              elow(n)=ead(ilower)
              eup(n)=ead(iupper)
              write(*,*) 'n,x3,ex,eup in 01_t20=',n,x3,ex,eup(n)
              x1=x2
              x2=x3
              x(n)=x3
              h=-(x2-x1)*(eup(n)-ex)
     &           /((eup(n)-ex)-(eup(n-1)-ex))
              nmax=n
              dh1=dh2
              dh2=h
              if(dh1*dh2 < 0.0d0) then
                maxh=maxh-1.0d0
              endif
            enddo
*
            t20=x3
            eup_t20=eup(n)
            elow_t20=elow(n)
            key10=1
            key1=0
            key2=0
*
            write(*,'(a,3f10.5,1pe10.2)')
     &           'Last h,x3,ex,err_dx in 01_t20=',h,x3,ex,err_dx
            write(*,*)
*
          maxh=5.0d0
            x3=0.0d0
            e3=0.0d0
            if ((t20-R0 >= 0.0d0) .and. ll >= 2) then
            x1=R0
            x2=xl(2)
            e1=elow_r0
            e2=elowl(2)
            eup(n)=eup_r0
            elow(n)=elow_r0
            write(*,*) 'x1,x2,e2,t20-R0>0, ll>2 in 01_t10='
     &      ,x1,x2,e2
            elseif ((t20-R0 < 0.0d0) .and. rr >=2) then
            x1=xr(2)
            x2=R0
            e1=elow_r0
            e2=elowr(2)
            eup(n)=eup_r0
            elow(n)=elow_r0
            write(*,*) 'x1,x2,e2,t20-R0<0, rr>2 in 01_t10='
     &      ,x1,x2,e2
            elseif ((t20-R0 >= 0.0d0) .and. ll <= 1) then
            x1=R0
            e1=elow_r0
            x2=R0-0.5d0
            call pot1d(r,x2,dir,ead,natom,nsurf)
            n=n+1
            e2=ead(iupper)
            eup(n)=ead(iupper)
            elow(n)=ead(ilower)
            write(*,*) 'x1,x2,e2,t20-R0>0, ll<1 in 01_t10='
     &      ,x1,x2,e2
            elseif ((t20-R0 < 0.0d0) .and. rr <= 1) then
            x1=R0
            e1=elow_r0
            x2=R0+0.5d0
            call pot1d(r,x2,dir,ead,natom,nsurf)
            n=n+1
            e2=ead(iupper)
            eup(n)=ead(iupper)
            elow(n)=ead(ilower)
            write(*,*) 'x1,x2,e2,t20-R0<0, rr<1 in 01_t10='
     &      ,x1,x2,e2
            endif
            h =-(x2-x1)*(e2-ex)/((e2-ex)-(e1-ex))
            dh1=h
            dh2=h
            x3=x2
            call pot1d(r,x2,dir,ead,natom,nsurf)
            n=n+1
            eup(n)=ead(iupper)
            elow(n)=ead(ilower)
            do while (n < maxn .and. abs(h) > err_dx )
              n=n+1
              if ( abs(h) > maxh ) h=sign(maxh,h)
              x3=x2+h
              write(*,'(a,3f10.5,1pe10.2)')
     &              'new h,x3,ex,err_dx in 01_t10=',h,x3,ex,err_dx
              call pot1d(r,x3,dir,ead,natom,nsurf)
              elow(n)=ead(ilower)
              eup(n)=ead(iupper)
              write(*,*) 'n,x3,ex,elow in 01_t10=',n,x3,ex,elow(n)
              x1=x2
              x2=x3
              x(n)=x3
              h=-(x2-x1)*(elow(n)-ex)
     &           /((elow(n)-ex)-(elow(n-1)-ex))
              nmax=n
              dh1=dh2
              dh2=h
              if(dh1*dh2 < 0.0d0) then
                maxh=maxh-1.0d0
              endif
            enddo
*
            t10=x3
            elow_t10=elow(n)
            eup_t10=eup(n)
            key8=1
            key1=0
            key2=0
*
            write(*,'(a,3f10.5,1pe10.2)')
     &           'Last h,x3,ex,err_dx in 01_t10=',h,x3,ex,err_dx
            write(*,*)
*
          endif
*
         icount=icount+1
         if ( icount==2) then
           go to 200
         endif

         if((key1==0).and.(key2==0).and.(key8==0).and.(key10==0))then
          maxh=5.0d0
            x3=0.0d0
            e3=0.0d0
             h=maxh
            n=n+1
          x1=-0.5d0
          x(n)=x1
          call der1d(r,x1,dir,e1,de1,natom,nsurf,ilower,inum)
          call der1d(r,x1,dir,e2,de2,natom,nsurf,iupper,inum)
          elow(n)=e1
          eup(n)=e2
          delow(n)=de1
          deup(n)=de2
            n=n+1
          x2=-0.5d0
          x(n)=x2
          call der1d(r,x2,dir,e1,de1,natom,nsurf,ilower,inum)
          call der1d(r,x2,dir,e2,de2,natom,nsurf,iupper,inum)
          elow(n)=e1
          eup(n)=e2
          delow(n)=de1
          deup(n)=de2
        do while((key4==0).and.(key6==0).and.(key12==0).and.(key14==0))
           if ((delow(n)*delow(n-1) < 0) .and. key1==0) then
             key4=1
            write(*,*)
             write(*,*)'key4=1 in icount=2'
            write(*,*)
             x4=x1
             x5=x2
             e4=e1
             e5=e2
             de4=de1
             de5=de2
             go to 111
           endif
           if ((deup(n)*deup(n-1) < 0) .and. key2==0) then
             key6=1
            write(*,*)
             write(*,*)'key6=1 in icount=2'
            write(*,*)
             x6=x1
             x7=x2
             e6=e1
             e7=e2
             de6=de1
             de7=de2
             go to 111
           endif
           if (((elow(n)-ex)*(elow(n-1)-ex) < 0) .and. key8==0) then
             key12=1
            write(*,*)
             write(*,*)'key12=1 in icount=2'
            write(*,*)
             x8=x1
             x9=x2
             e8=elow(n-1)
             e9=elow(n)
             go to 111
           endif
           if (((eup(n)-ex)*(eup(n-1)-ex) < 0) .and. key10==0) then
             key14=1
            write(*,*)
             write(*,*)'key14=1 in icount=2'
            write(*,*)
             x10=x1
             x11=x2
             e10=eup(n-1)
             e11=eup(n)
             go to 111
           endif
            x2=-1.0d0*x2
            if (x2<0.0d0) x3=x2-0.5d0
            if (x2>0.0d0) x3=x2+0.5d0
            n=n+1
            call der1d(r,x3,dir,e1,de1,natom,nsurf,ilower,inum)
            call der1d(r,x3,dir,e2,de2,natom,nsurf,iupper,inum)
            dde3=de2-de1
            write(*,*) 'n,x3,dde3 in findR0_LZ_NT_icount_2=',n,x3,dde3
            x1=x2
            x2=x3
            x(n)=x3
            elow(n)=e1
            eup(n)=e2
            delow(n)=de1
            deup(n)=de2
 111     continue
          enddo
*
          go to 100
          endif
*
 200    continue

        if ((key1==0) .and. (key2==0)) then

             n=nmax

          maxh=5.0d0
             x3=0.0d0
             h=maxh
             x1=t10
             x2=t10+0.5d0
             n=n+1
             call pot1d(r,x2,dir,ead,natom,nsurf)
             eup(n)=ead(iupper)
             elow(n)=ead(ilower)
             h=-(x2-x1)*(elow(n)-etot1d)
     &         /((elow(n)-etot1d)-(elow_t10-etot1d))
            dh1=h
            dh2=h
             x3=x2
             do while ( n < maxn .and. abs(x2-x1) > err_dx )
               n=n+1
!               if ( abs(h) > maxh+100.d0 ) h=sign(maxh,h)
               if ( abs(h) > maxh ) then
                 if (t10-t20 > 0.0d0) then
                   if(etot1d-ex>0.0d0) h=maxh
                   if(etot1d-ex<0.0d0) h=-maxh
                 else
                   if(etot1d-ex>0.0d0) h=-maxh
                   if(etot1d-ex<0.0d0) h=maxh
                 endif
               endif
               x3=x2+h
               write(*,'(a,3f10.5,1pe10.2)')
     &         'new h,x3,etot1d,err_dx in LZ_t1=',h,x3,etot1d,err_dx
                call pot1d(r,x3,dir,ead,natom,nsurf)
                eup(n)=ead(iupper)
                elow(n)=ead(ilower)
            write(*,*)'n,x3,etot1d,elow in LZ_t1=',n,x3,etot1d,elow(n)
               x1=x2
               x2=x3
               x(n)=x3
               h=-(x2-x1)*(elow(n)-etot1d)
     &           /((elow(n)-etot1d)-(elow(n-1)-etot1d))
              write(*,*)'h',h
              dh1=dh2
              dh2=h
              if(dh1*dh2 < 0.0d0) then
                maxh=maxh-1.0d0
                if (maxh == 0.0d0) maxh = 5.0d0
              endif
             enddo
*
             t1=x3
*
            write(*,'(a,3f10.5,1pe10.2)')
     &           'Last h,x3,etot1d,err_dx in LZ_t1=',h,x3,etot1d,err_dx
            write(*,*)

             maxh=5.0d0
             x3=0.0d0
             h=maxh
             x1=t20
             x2=t20+0.5d0
             n=n+1
             call pot1d(r,x2,dir,ead,natom,nsurf)
             eup(n)=ead(iupper)
             elow(n)=ead(ilower)
             h=-(x2-x1)*(eup(n)-etot1d)
     &         /((eup(n)-etot1d)-(eup_t20-etot1d))
            dh1=h
            dh2=h
             x3=x2
             do while ( n < maxn .and. abs(x2-x1) > err_dx )
               n=n+1
               if ( abs(h) > maxh ) then
                 if (t10-t20 > 0.0d0) then
                   if(etot1d-ex>0.0d0) h=maxh
                   if(etot1d-ex<0.0d0) h=-maxh
                 else
                   if(etot1d-ex>0.0d0) h=-maxh
                   if(etot1d-ex<0.0d0) h=maxh
                 endif
               endif
               x3=x2+h
               write(*,'(a,3f10.5,1pe10.2)')
     &         'new h,x3,etot1d,err_dx in LZ_t2=',h,x3,etot1d,err_dx
                call pot1d(r,x3,dir,ead,natom,nsurf)
                eup(n)=ead(iupper)
                elow(n)=ead(ilower)
            write(*,*) 'n,x3,etot1d,elow in LZ_t2=',n,x3,etot1d,eup(n)
               x1=x2
               x2=x3
               x(n)=x3
               h=-(x2-x1)*(eup(n)-etot1d)
     &           /((eup(n)-etot1d)-(eup(n-1)-etot1d))
              dh1=dh2
              dh2=h
              if(dh1*dh2 < 0.0d0) then
                maxh=maxh-1.0d0
              endif
             enddo
*
             t2=x3

            write(*,'(a,3f10.5,1pe10.2)')
     &           'Last h,x3,etot1d,err_dx in LZ_t2=',h,x3,etot1d,err_dx
            write(*,*)

            do i=1,n
              do j=1,n
                if ( x(i) < x(j) )then
                  xx=x(i)
                  x(i)=x(j)
                  x(j)=xx
                  ee=elow(i)
                  elow(i)=elow(j)
                  elow(j)=ee
                  ee=eup(i)
                  eup(i)=eup(j)
                  eup(j)=ee
                endif
             enddo
           enddo

          sigma=0.0d0
          delta=0.0d0

          if (etot1d >= eup_r0) then
            ierr=0

            if (R0-t1>=0.0d0) then

              j=0
              do i=1,n
                if((t1<=x(i)) .and. (R0>=x(i)))then
                  j=j+1
                  xxx(j)=x(i)
                  eee(j)=elow(i)
               write(*,*) 'j,xxx,eee,etot1d',j,xxx(j),eee(j),etot1d
                endif
              enddo
              m=j
              write(*,*) 'm',m

              sum=0.0d0
              do i=1,m
                if ( eee(i) > etot1d) then
                  k(i)=dsqrt(2.0d0*(eee(i)-etot1d))
                else
                  k(i)=dsqrt(2.0d0*(etot1d-eee(i)))
                endif
                if (i>2) then
                  sum=sum+0.5d0*(xxx(i)-xxx(i-1))*(k(i)+k(i-1))
                endif
              enddo
              sigma=sum

            elseif(R0-t1<0.0d0) then
              j=0
              do i=1,n
                if((R0<=x(i)) .and. (t1>=x(i)))then
                  j=j+1
                  xxx(j)=x(i)
                  eee(j)=elow(i)
               write(*,*) 'j,xxx,eee,etot1d',j,xxx(j),eee(j),etot1d
                endif
              enddo
              m=j
              write(*,*) 'm',m

              sum=0.0d0
              do i=1,m
                if ( eee(i) > etot1d) then
                  k(i)=dsqrt(2.0d0*(eee(i)-etot1d))
                else
                  k(i)=dsqrt(2.0d0*(etot1d-eee(i)))
                endif
                if (i>2) then
                  sum=sum+0.5d0*(xxx(i)-xxx(i-1))*(k(i)+k(i-1))
                endif
              enddo
              sigma=-sum
            endif

            if (R0-t2>=0.0d0) then
              j=0
              do i=1,n
                if((t2<=x(i)) .and. (R0>=x(i)))then
                  j=j+1
                  xxx(j)=x(i)
                  eee(j)=eup(i)
               write(*,*) 'j,xxx,eee,etot1d',j,xxx(j),eee(j),etot1d
                endif
              enddo
              m=j
              write(*,*) 'm',m

              sum=0.0d0
              do i=1,m
                if ( eee(i) > etot1d) then
                  k(i)=dsqrt(2.0d0*(eee(i)-etot1d))
                else
                  k(i)=dsqrt(2.0d0*(etot1d-eee(i)))
                endif
                if (i>2) then
                  sum=sum+0.5d0*(xxx(i)-xxx(i-1))*(k(i)+k(i-1))
                endif
              enddo
              sigma=sigma-sum

            elseif (R0-t2<0.0d0) then
              j=0
              do i=1,n
                if((R0<=x(i)) .and. (t2>=x(i)))then
                  j=j+1
                  xxx(j)=x(i)
                  eee(j)=eup(i)
               write(*,*) 'j,xxx,eee,etot1d',j,xxx(j),eee(j),etot1d
                endif
              enddo
              m=j
              write(*,*) 'm',m

              sum=0.0d0
              do i=1,m
                if ( eee(i) > etot1d) then
                  k(i)=dsqrt(2.0d0*(eee(i)-etot1d))
                else
                  k(i)=dsqrt(2.0d0*(etot1d-eee(i)))
                endif
                if (i>2) then
                  sum=sum+0.5d0*(xxx(i)-xxx(i-1))*(k(i)+k(i-1))
                endif
              enddo
              sigma=sigma+sum
            endif

          elseif(etot1d>elow_r0) then

            if (R0-t1>=0.0d0) then

              j=0
              do i=1,n
                if((t1<=x(i)) .and. (R0>=x(i)))then
                  j=j+1
                  xxx(j)=x(i)
                  eee(j)=elow(i)
               write(*,*) 'j,xxx,eee,etot1d',j,xxx(j),eee(j),etot1d
                endif
              enddo
              m=j
              write(*,*) 'm',m

              sum=0.0d0
              do i=1,m
                if ( eee(i) > etot1d) then
                  k(i)=dsqrt(2.0d0*(eee(i)-etot1d))
                else
                  k(i)=dsqrt(2.0d0*(etot1d-eee(i)))
                endif
                if (i>2) then
                  sum=sum+0.5d0*(xxx(i)-xxx(i-1))*(k(i)+k(i-1))
                endif
              enddo
              sigma=sum

            elseif(R0-t1<0.0d0) then
              j=0
              do i=1,n
                if((R0<=x(i)) .and. (t1>=x(i)))then
                  j=j+1
                  xxx(j)=x(i)
                  eee(j)=elow(i)
               write(*,*) 'j,xxx,eee,etot1d',j,xxx(j),eee(j),etot1d
                endif
              enddo
              m=j
              write(*,*) 'm',m

              sum=0.0d0
              do i=1,m
                if ( eee(i) > etot1d) then
                  k(i)=dsqrt(2.0d0*(eee(i)-etot1d))
                else
                  k(i)=dsqrt(2.0d0*(etot1d-eee(i)))
                endif
                if (i>2) then
                  sum=sum+0.5d0*(xxx(i)-xxx(i-1))*(k(i)+k(i-1))
                endif
              enddo
              sigma=-sum
            endif
            if (R0-t2>=0.0d0) then
              j=0
              do i=1,n
                if((t2<=x(i)) .and. (R0>=x(i)))then
                  j=j+1
                  xxx(j)=x(i)
                  eee(j)=eup(i)
               write(*,*) 'j,xxx,eee,etot1d',j,xxx(j),eee(j),etot1d
                endif
              enddo
              m=j
              write(*,*) 'm',m

              sum=0.0d0
              do i=1,m
                if ( eee(i) > etot1d) then
                  k(i)=dsqrt(2.0d0*(eee(i)-etot1d))
                else
                  k(i)=dsqrt(2.0d0*(etot1d-eee(i)))
                endif
                if (i>2) then
                  sum=sum+0.5d0*(xxx(i)-xxx(i-1))*(k(i)+k(i-1))
                endif
              enddo
              delta=-sum

            elseif (R0-t2<0.0d0) then
              j=0
              do i=1,n
                if((R0<=x(i)) .and. (t2>=x(i)))then
                  j=j+1
                  xxx(j)=x(i)
                  eee(j)=eup(i)
               write(*,*) 'j,xxx,eee,etot1d',j,xxx(j),eee(j),etot1d
                endif
              enddo
              m=j
              write(*,*) 'm',m

              sum=0.0d0
              do i=1,m
                if ( eee(i) > etot1d) then
                  k(i)=dsqrt(2.0d0*(eee(i)-etot1d))
                else
                  k(i)=dsqrt(2.0d0*(etot1d-eee(i)))
                endif
                if (i>2) then
                  sum=sum+0.5d0*(xxx(i)-xxx(i-1))*(k(i)+k(i-1))
                endif
              enddo
              delta=sum
            endif

          elseif(etot1d<=elow_r0) then

            if (R0-t1>=0.0d0) then

              j=0
              do i=1,n
                if((t1<=x(i)) .and. (R0>=x(i)))then
                  j=j+1
                  xxx(j)=x(i)
                  eee(j)=elow(i)
               write(*,*) 'j,xxx,eee,etot1d',j,xxx(j),eee(j),etot1d
                endif
              enddo
              m=j
              write(*,*) 'm',m

              sum=0.0d0
              do i=1,m
                if ( eee(i) > etot1d) then
                  k(i)=dsqrt(2.0d0*(eee(i)-etot1d))
                else
                  k(i)=dsqrt(2.0d0*(etot1d-eee(i)))
                endif
                if (i>2) then
                  sum=sum+0.5d0*(xxx(i)-xxx(i-1))*(k(i)+k(i-1))
                endif
              enddo
              delta=sum

            elseif(R0-t1<0.0d0) then
              j=0
              do i=1,n
                if((R0<=x(i)) .and. (t1>=x(i)))then
                  j=j+1
                  xxx(j)=x(i)
                  eee(j)=elow(i)
               write(*,*) 'j,xxx,eee,etot1d',j,xxx(j),eee(j),etot1d
                endif
              enddo
              m=j
              write(*,*) 'm',m

              sum=0.0d0
              do i=1,m
                if ( eee(i) > etot1d) then
                  k(i)=dsqrt(2.0d0*(eee(i)-etot1d))
                else
                  k(i)=dsqrt(2.0d0*(etot1d-eee(i)))
                endif
                if (i>2) then
                  sum=sum+0.5d0*(xxx(i)-xxx(i-1))*(k(i)+k(i-1))
                endif
              enddo
              delta=-sum
            endif

            if (R0-t2>=0.0d0) then
              j=0
              do i=1,n
                if((t2<=x(i)) .and. (R0>=x(i)))then
                  j=j+1
                  xxx(j)=x(i)
                  eee(j)=eup(i)
               write(*,*) 'j,xxx,eee,etot1d',j,xxx(j),eee(j),etot1d
                endif
              enddo
              m=j
              write(*,*) 'm',m

              sum=0.0d0
              do i=1,m
                if ( eee(i) > etot1d) then
                  k(i)=dsqrt(2.0d0*(eee(i)-etot1d))
                else
                  k(i)=dsqrt(2.0d0*(etot1d-eee(i)))
                endif
                if (i>2) then
                  sum=sum+0.5d0*(xxx(i)-xxx(i-1))*(k(i)+k(i-1))
                endif
              enddo
              delta=delta-sum

            elseif (R0-t2<0.0d0) then
              j=0
              do i=1,n
                if((R0<=x(i)) .and. (t2>=x(i)))then
                  j=j+1
                  xxx(j)=x(i)
                  eee(j)=eup(i)
               write(*,*) 'j,xxx,eee,etot1d',j,xxx(j),eee(j),etot1d
                endif
              enddo
              m=j
              write(*,*) 'm',m

              sum=0.0d0
              do i=1,m
                if ( eee(i) > etot1d) then
                  k(i)=dsqrt(2.0d0*(eee(i)-etot1d))
                else
                  k(i)=dsqrt(2.0d0*(etot1d-eee(i)))
                endif
                if (i>2) then
                  sum=sum+0.5d0*(xxx(i)-xxx(i-1))*(k(i)+k(i-1))
                endif
              enddo
              delta=delta+sum
            endif

          endif

        elseif ((key1==1) .and. (key2==1)) then
        sigma=0.0d0
        delta=0.0d0

          if ((etot1d >= eb) .and. (is0==ilower)) then
            ierr=0
            t1=0.0d0
            t2=0.0d0
*
            n=nmax
            do nlr=1,2
*
*         nlr=1: left side solution
*         nlr=2: right side solution
*
              x3=0.0d0
              e3=0.0d0
              x1=rb
              e1=eb
              n=n+1
             if (nlr == 1) then
               x2=rb-2.0d0
               x(n)=x2
             else if (nlr ==2) then
               x2=rb+2.0d0
               x(n)=x2
             endif
             write(*,'(a,2f10.5,1pe10.2)')
     &            'new h,x2,err_dx in findR0_etot1d>eb=',h,x2,err_dx
              call pot1d(r,x2,dir,ead,natom,nsurf)
              e2=ead(iupper)
              eup(n)=ead(iupper)
              elow(n)=ead(ilower)
             write(*,*) 'n,x2,elow in findR0_etot1d>eb=',n,x2,eup(n)
               h=-(x2-x1)*(e2-etot1d)
     &           /((e2-etot1d)-(e1-etot1d))
               dh1=h
               dh2=h
               x3=x2
             do while ( n < maxn .and. abs(x2-x1) > err_dx )
               n=n+1
               if ( abs(h) > maxh ) h=sign(maxh,h)
               x3=x2+h
               write(*,'(a,2f10.5,1pe10.2)')
     &              'new h,x3,err_dx in findR0_etot1d>eb=',h,x3,err_dx
                call pot1d(r,x3,dir,ead,natom,nsurf)
                eup(n)=ead(iupper)
                elow(n)=ead(ilower)
               write(*,*) 'n,x3,elow in findR0_etot1d>eb=',n,x3,eup(n)
               x1=x2
               x2=x3
               x(n)=x3
               h=-(x2-x1)*(eup(n)-etot1d)
     &           /((eup(n)-etot1d)-(eup(n-1)-etot1d))
              dh1=dh2
              dh2=h
              if(dh1*dh2 < 0.0d0) then
                maxh=maxh-1.0d0
              endif
             enddo
*
             if ((nlr == 1) .and. (rb-x3>=0.0d0))then
               t1=x3
            write(*,'(a,2f10.5,1pe10.2)')
     &           'Last h,x3,err_dx in etot1d>eb(t1=x3)=',h,x3,err_dx
            write(*,*)
             else if ((nlr == 2) .and. (rb-x3<=0.0d0))then
               t2=x3
            write(*,'(a,2f10.5,1pe10.2)')
     &           'Last h,x3,err_dx in etot1d>eb(t1=x3)=',h,x3,err_dx
            write(*,*)
             endif
           enddo
*
            do i=1,n
              do j=1,n
                if ( x(i) < x(j) )then
                  xx=x(i)
                  x(i)=x(j)
                  x(j)=xx
                  ee=eup(i)
                  eup(i)=eup(j)
                  eup(j)=ee
                endif
             enddo
           enddo

           write(*,*) 't1,t2',t1,t2

           if ((t1/=0.0d0) .and. (t2/=0.0d0)) then

           j=0
           do i=1,n
             if((t1<=x(i)) .and. (t2>=x(i)))then
               j=j+1
               xxx(j)=x(i)
               eee(j)=eup(i)
               write(*,*) 'j,xxx,eee,etot1d',j,xxx(j),eee(j),etot1d
             endif
           enddo
           m=j
           write(*,*) 'm',m

           sum=0.0d0
           do i=1,m
             if ( eee(i) > etot1d) then
               k(i)=dsqrt(2.0d0*(eee(i)-etot1d))
             else
               k(i)=dsqrt(2.0d0*(etot1d-eee(i)))
             endif
             if (i>2) then
               sum=sum+0.5d0*(xxx(i)-xxx(i-1))*(k(i)+k(i-1))
             endif
           enddo

           sigma=sum

           j=0
           do i=1,n
             if((t1<=x(i)) .and. (rb>=x(i)))then
               j=j+1
               xxx(j)=x(i)
               eee(j)=eup(i)
               write(*,*) 'j,xxx,eee,etot1d',j,xxx(j),eee(j),etot1d
             endif
           enddo
           m=j
           write(*,*) 'm',m

           sum=0.0d0
           do i=1,m
             if ( eee(i) > etot1d) then
               k(i)=dsqrt(2.0d0*(eee(i)-etot1d))
             else
               k(i)=dsqrt(2.0d0*(etot1d-eee(i)))
             endif
             if (i>2) then
               sum=sum+0.5d0*(xxx(i)-xxx(i-1))*(k(i)+k(i-1))
             endif
           enddo

           del11=sum

           j=0
           do i=1,n
             if((rb<=x(i)) .and. (t2>=x(i)))then
               j=j+1
               xxx(j)=x(i)
               eee(j)=eup(i)
               write(*,*) 'j,xxx,eee,etot1d',j,xxx(j),eee(j),etot1d
             endif
           enddo
           m=j
           write(*,*) 'm',m

           sum=0.0d0
           do i=1,m
             if ( eee(i) > etot1d) then
               k(i)=dsqrt(2.0d0*(eee(i)-etot1d))
             else
               k(i)=dsqrt(2.0d0*(etot1d-eee(i)))
             endif
             if (i>2) then
               sum=sum+0.5d0*(xxx(i)-xxx(i-1))*(k(i)+k(i-1))
             endif
           enddo

           del22=sum

           endif

         else if (etot1d < et) then
           ierr=0
*
             n=nmax
           do nlr=1,2
*
*         nlr=1: left side solution
*         nlr=2: right side solution
*
             x3=0.0d0
             e3=0.0d0
             x1=rt
             e1=et
             n=n+1
             if (nlr == 1) then
               x2=rt-2.0d0
               x(n)=x2
             else if (nlr ==2) then
               x2=rt+2.0d0
               x(n)=x2
             endif
             write(*,'(a,2f10.5,1pe10.2)')
     &            'new h,x2,err_dx in findR0_etot1d<et=',h,x2,err_dx
              call pot1d(r,x2,dir,ead,natom,nsurf)
              eup(n)=ead(iupper)
              elow(n)=ead(ilower)
             write(*,*) 'n,x2,elow in findR0_etot1d<et=',n,x2,elow(n)
              e2=ead(ilower)
              h=-(x2-x1)*(e2-etot1d)
     &           /((e2-etot1d)-(e1-etot1d))
               dh1=h
               dh2=h
              x3=x2
             do while ( n < maxn .and. abs(x2-x1) > err_dx )
               n=n+1
               if ( abs(h) > maxh ) h=sign(maxh,h)
               x3=x2+h
               write(*,'(a,2f10.5,1pe10.2)')
     &              'new h,x3,err_dx in findR0_etot1d<et=',h,x3,err_dx
                call pot1d(r,x3,dir,ead,natom,nsurf)
                eup(n)=ead(iupper)
                elow(n)=ead(ilower)
               write(*,*) 'n,x3,elow in findR0_etot1d<et=',n,x3,elow(n)
               x1=x2
               x2=x3
               x(n)=x3
               h=-(x2-x1)*(elow(n)-etot1d)
     &           /((elow(n)-etot1d)-(elow(n-1)-etot1d))
              dh1=dh2
              dh2=h
              if(dh1*dh2 < 0.0d0) then
                maxh=maxh-1.0d0
              endif
             enddo
*
             if ((nlr == 1) .and. (rt-x3>=0.0d0))then
               t1l=x3
            write(*,'(a,2f10.5,1pe10.2)')
     &           'Last h,x3,err_dx in etot1d<et(t1l=x3)=',h,x3,err_dx
            write(*,*)
             else if ((nlr == 2) .and. (rt-x3<=0.0d0))then
               t1r=x3
            write(*,'(a,2f10.5,1pe10.2)')
     &           'Last h,x3,err_dx in etot1d<et(t1r=x3)=',h,x3,err_dx
            write(*,*)
             endif
           enddo

            do j=1,n
               write(*,*) 'j,x,elow',j,x(j),elow(j)
            enddo
            do i=1,n
              do j=1,n
                if ( x(i) < x(j) )then
                  xx=x(i)
                  x(i)=x(j)
                  x(j)=xx
                  ee=elow(i)
                  elow(i)=elow(j)
                  elow(j)=ee
                endif
             enddo
           enddo

            do j=1,n
               write(*,*) 'j,x,elow',j,x(j),elow(j)
            enddo

               write(*,*) 't1l,t1r',t1l,t1r
           j=0
           do i=1,n
             if((t1l<=x(i)) .and. (t1r>=x(i)))then
               j=j+1
               xxx(j)=x(i)
               eee(j)=elow(i)
               write(*,*) 'j,xxx,eee,etot1d',j,xxx(j),eee(j),etot1d
             endif
           enddo
           m=j
           write(*,*) 'm',m

           sum=0.0d0
           do i=1,m
             if ( eee(i) > etot1d) then
               k(i)=dsqrt(2.0d0*(eee(i)-etot1d))
             else
               k(i)=dsqrt(2.0d0*(etot1d-eee(i)))
             endif
             if (i>2) then
               sum=sum+0.5d0*(xxx(i)-xxx(i-1))*(k(i)+k(i-1))
             endif
           enddo
           delta=sum

         endif

        x3=0.5d0*(rt+rb)
        call pot1d(r,x3,dir,ead,natom,nsurf)
        gamma=(eb-et)/(ead(iupper)-ead(ilower))
        write(*,'(a,1p4e15.7)') 'de,ead,gamma=',
     &            eb-et,ead(iupper),ead(ilower),gamma

        if(dabs(gamma-1.d0).lt.1.d-6) then

          do i=1,n
            do j=1,n
              if ( x(i) < x(j) )then
                xx=x(i)
                x(i)=x(j)
                x(j)=xx
                ee=eup(i)
                eup(i)=eup(j)
                eup(j)=ee
                ee=elow(i)
                elow(i)=elow(j)
                elow(j)=ee
              endif
            enddo
          enddo

            do j=1,n
               write(*,*) 'j,x,elow,eup',j,x(j),elow(j),eup(j)
            enddo

          do i=1,n
            if (rt==x(i)) then
              x1=0.5d0*(x(i)-x(i-1))
              x2=0.5d0*(x(i+1)-x(i))
              de1=(elow(i)-elow(i-1))/(x(i)-x(i-1))
              de2=(elow(i+1)-elow(i))/(x(i+1)-x(i))
            endif
          enddo

          hess_rt=((rt-x2)*de1+(rt-x1)*de2)/((rt-x1)+(rt-x2))

          do i=1,n
            if (rb==x(i)) then
              x1=0.5d0*(x(i)-x(i-1))
              x2=0.5d0*(x(i+1)-x(i))
              de1=(eup(i)-eup(i-1))/(x(i)-x(i-1))
              de2=(eup(i+1)-eup(i))/(x(i+1)-x(i))
            endif
          enddo

          hess_rb=((rb-x2)*de1+(rb-x1)*de2)/((rb-x1)+(rb-x2))

          aa=(0.25d0/(eb-et))*(hess_rb-hess_rt)
        else
          aa=(1-gamma*gamma)/(((rb-rt)**2.0d0)*(eb-et))
        endif

        endif
        return
        end
