        subroutine omega(a,b,c,res,jerr)
* ----  Calculates the Integral_0^\infty cos(t^3/3-J(t))dt,
*                         where J(t)=a*t+t/(b+c*t)
        implicit none
        real*8 a,b,c,res
        integer jerr
        integer, parameter :: ndim=5000
        real*8 xx(ndim),ww(ndim)
        common/FUNJ/a1,b1,c1
*
        real*8 a1,b1,c1,tol,up,ares,tt,temp,est1,est2,est3,est
        real*8 x1,x2,y,ss,cc,arg,sum,t6,t7,t8,ft1,ft2,fun
        real*8, external :: fj,fj1,fj2
        integer ndvr,ndvr1,i
*
        jerr=0
        a1=a
        b1=b
        c1=c
* ----  estimation of the upper limit ----
        tol=0.01d0
        up=80.d0
        ares=1.d0
5       continue
        do 10 i=1,20
        up=up+20.d0
        tt=(3.*up)**(1.d0/3.d0)
        temp=up**(1.d0/3.d0)
        est1=0.3/temp/temp/up
        est2=0.3*fj1(tt)/temp/up
        est3=(fj1(tt)*fj1(tt)-fj2(tt))/9.d0/up
        est=max(est1,est2,est3)
        if(est/ares.lt.tol)goto 20
10     continue
20     continue
* ----  First integral ----
        res=0.d0
        x1=0.d0
        x2=1.d0
        ndvr=up
           if(ndvr.gt.ndim)then
              jerr=-1
              write(*,*)'increase ndim in omega.f'
c             stop'omega.f'
              return
           endif
        ndvr1=100
        call gaulegg(x1,x2,xx,ww,ndvr1)
        do i=1,ndvr1
        tt=xx(i)
        res=res+ww(i)*dcos(tt*tt*tt/3.d0-fj(tt))
        enddo
*
        tt=1.d0
        x1=1.d0/3.d0
        x2=up
        arg=x1-fj(tt)
        res=res-dsin(arg)
     &         +2.d0*dcos(arg)
     &         -fj1(tt)*dsin(arg)
* ---- Second integration ----
        call gaulegg(x1,x2,xx,ww,ndvr)
        sum=0.d0
*
        DO i=1,NDVR
        y=xx(i)
        tt=(3.d0*y)**(1.d0/3.d0)
        arg=y-fj(tt)
        ss=dsin(arg)
        cc=dcos(arg)
        t6=9.d0*y*y
        t7=t6*tt
        t8=t7*tt
        ft1=fj1(tt)
        ft2=fj2(tt)
           fun=-10.d0*cc/t8
     &            +6.d0*ft1*ss/t7
     &            -ft2*ss/t6
     &            +ft1*ft1*cc/t6
        sum=sum+fun*ww(i)
        END DO
*
        res=res+sum
* ---- Final estimate ----
        ares=dabs(res)
        if(est/ares.gt.tol)then
        up=up*est/ares/tol
        goto 5
        endif
        return
        end
